package cn.com.ctop.common.module.model;

import cn.com.ctop.common.module.entity.SysDepart;
import lombok.Data;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 部门表 封装树结构的部门的名称的实体类
 * <p>
 *
 * @author Steve
 * @since 2019-01-22
 *
 */
@Data
public class DepartIdModel implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键ID
     */
    private String key;

    /**
     * 主键ID
     */
    private String value;

    /**
     * 部门名称
     */
    private String title;
    private String orgCode;

    List<DepartIdModel> children = new ArrayList<>();

    /**
     * 将SysDepartTreeModel的部分数据放在该对象当中
     * @param treeModel 树状结构
     * @return 部门信息
     */
    public DepartIdModel convert(SysDepartTreeModel treeModel) {
        this.key = treeModel.getId();
        this.value = treeModel.getId();
        this.title = treeModel.getTitle();
        this.orgCode = treeModel.getOrgCode();
        return this;
    }

    /**
     * 该方法为用户部门的实现类所使用
     * @param sysDepart 系统部门信息
     * @return 部门信息
     */
    public DepartIdModel convertByUserDepart(SysDepart sysDepart) {
        this.key = sysDepart.getId();
        this.value = sysDepart.getId();
        this.title = sysDepart.getDepartName();
        return this;
    }
}
